#!/bin/bash

if [ -z $1 ] ; then
	echo "Usage: $0 PortXmitData|PortRcvData|PortXmitPkts|PortRcvPkts"
	exit 1
fi
COUNTER=$1

declare -a HCAS_ARRAY
declare -a PORTS_STATE


function one_hca()
{
	if ( /usr/bin/vstat > /dev/null 2>&1 ) ; then
		PORT1=`/usr/bin/vstat | grep -A 1 port=1 | grep port_state | awk -F "=" ' {print $2}'`
		PORT2=`/usr/bin/vstat | grep -A 1 port=2 | grep port_state | awk -F "=" ' {print $2}'`
	fi
	HCA_ID=`/usr/bin/vstat | grep "hca_id" | awk -F= ' {print $2}'`
	# Get Counters
	if [[ $PORT1 = "PORT_ACTIVE" ]] ; then
		case "$COUNTER" in
		PortXmitData)
			typeset -i DATA=`/usr/mellanox/bin/get_pcounter -h $HCA_ID -p 1 | grep PortXmitData | awk ' { print $2 }'`
			/usr/mellanox/bin/get_pcounter -h $HCA_ID -p 1 -s 1  > /dev/null 2>&1
			TYPE="MB" 
		;;
		PortRcvData)
			typeset -i DATA=`/usr/mellanox/bin/get_pcounter -h $HCA_ID -p 1 | grep PortRcvData | awk ' { print $2 }'`
			/usr/mellanox/bin/get_pcounter -h $HCA_ID -p 1 -s 2 > /dev/null 2>&1
			TYPE="MB" 
		;;
		PortXmitPkts)
			typeset -i DATA=`/usr/mellanox/bin/get_pcounter -h $HCA_ID -p 1 | grep PortXmitPkts | awk ' { print $2 }'`
			/usr/mellanox/bin/get_pcounter -h $HCA_ID -p 1 -s 3 > /dev/null 2>&1
			TYPE="Packet" 
		;;
		PortRcvPkts)
			typeset -i DATA=`/usr/mellanox/bin/get_pcounter -h $HCA_ID -p 1 | grep PortRcvPkts | awk ' { print $2 }'`
			/usr/mellanox/bin/get_pcounter -h $HCA_ID -p 1 -s 4 > /dev/null 2>&1
			TYPE="Packet" 
		;;
		esac
		if [[ "$TYPE" == "Packet" ]] ; then
			typeset -i OUTPUT=($DATA)/10
		else
			typeset -i OUTPUT=($DATA)/10*4/1024/1024
		fi
		gmetric -n$COUNTER -v$OUTPUT -tint8 -u"$TYPE/Sec" -x10 -spositive
		#echo "$OUTPUT"
	fi
	if [[ $PORT2 = "PORT_ACTIVE" ]] ; then
		case "$COUNTER" in
		PortXmitData)
			typeset -i DATA=`/usr/mellanox/bin/get_pcounter -h $HCA_ID -p 2 | grep PortXmitData | awk ' { print $2 }'`
			/usr/mellanox/bin/get_pcounter -h $HCA_ID -p 2 -s 1 > /dev/null 2>&1  
			TYPE="MB" 
		;;
		PortRcvData)
			typeset -i DATA=`/usr/mellanox/bin/get_pcounter -h $HCA_ID -p 2 | grep PortRcvData | awk ' { print $2 }'`
			/usr/mellanox/bin/get_pcounter -h $HCA_ID -p 2 -s 2 > /dev/null 2>&1  
			TYPE="MB" 
		;;
		PortXmitPkts)
			typeset -i DATA=`/usr/mellanox/bin/get_pcounter -h $HCA_ID -p 2 | grep PortXmitPkts | awk ' { print $2 }'`
			/usr/mellanox/bin/get_pcounter -h $HCA_ID -p 2 -s 3 > /dev/null 2>&1  
			TYPE="Packet" 
		;;
		PortRcvPkts)
			typeset -i DATA=`/usr/mellanox/bin/get_pcounter -h $HCA_ID -p 2 | grep PortRcvPkts | awk ' { print $2 }'`
			/usr/mellanox/bin/get_pcounter -h $HCA_ID -p 2 -s 4 > /dev/null 2>&1  
			TYPE="Packet" 
		;;
		esac
		if [[ "$TYPE" == "Packet" ]] ; then
			typeset -i OUTPUT=($DATA)/10
		else
			typeset -i OUTPUT=($DATA)/10*4/1024/1024
		fi
		gmetric -n$COUNTER -v$OUTPUT -tint32  -u"$TYPE/Sec" -x10 -spositive
		#echo "$OUTPUT"
	fi
}
function two_hcas()
{
	HCAS_ARRAY=(`/usr/bin/vstat | grep "hca_id" | awk -F= ' {print $2}'`)
	PORT_STATES=(`/usr/bin/vstat | grep "port_state" | awk -F= ' {print $2}'`)

	for ((s=0;s<2;s++)); do
	   if [[ "${PORT_STATES[$s]}" ==  "PORT_ACTIVE" ]] ; then
           	#echo " ${HCAS_ARRAY[$s]} is active "

		case "$COUNTER" in
		PortXmitData)
			typeset -i DATA=`/usr/mellanox/bin/get_pcounter -h ${HCAS_ARRAY[$s]} -p 1 | grep PortXmitData | awk ' { print $2 }'`
			/usr/mellanox/bin/get_pcounter -h ${HCAS_ARRAY[$s]} -p 1 -s 1  > /dev/null 2>&1
			TYPE="MB" 
		;;
		PortRcvData)
			typeset -i DATA=`/usr/mellanox/bin/get_pcounter -h ${HCAS_ARRAY[$s]} -p 1 | grep PortRcvData | awk ' { print $2 }'`
			/usr/mellanox/bin/get_pcounter -h ${HCAS_ARRAY[$s]} -p 1 -s 2 > /dev/null 2>&1
			TYPE="MB" 
		;;
		PortXmitPkts)
			typeset -i DATA=`/usr/mellanox/bin/get_pcounter -h ${HCAS_ARRAY[$s]} -p 1 | grep PortXmitPkts | awk ' { print $2 }'`
			/usr/mellanox/bin/get_pcounter -h ${HCAS_ARRAY[$s]} -p 1 -s 3 > /dev/null 2>&1
			TYPE="Packet" 
		;;
		PortRcvPkts)
			typeset -i DATA=`/usr/mellanox/bin/get_pcounter -h ${HCAS_ARRAY[$s]} -p 1 | grep PortRcvPkts | awk ' { print $2 }'`
			/usr/mellanox/bin/get_pcounter -h ${HCAS_ARRAY[$s]} -p 1 -s 4 > /dev/null 2>&1
			TYPE="Packet" 
		;;
		esac
		if [[ "$TYPE" == "Packet" ]] ; then
			typeset -i OUTPUT=($DATA)/10
		else
			typeset -i OUTPUT=($DATA)/10*4/1024/1024
		fi
		#echo "gmetric -n${HCAS_ARRAY[$s]}__$COUNTER -v$OUTPUT -tint8 -u"$TYPE/Sec" -x10 -spositive"
		gmetric -n${HCAS_ARRAY[$s]}__$COUNTER -v$OUTPUT -tint8 -u"$TYPE/Sec" -x10 -spositive
	   #else
           # 	echo " ${HCAS_ARRAY[$s]} is down "
	   fi	
        done
 
	exit 2
}
function InfiniHost0 ()
{
	echo "inside InfiniHost0"
}

function InfiniHost_III ()
{
	echo "inside InfiniHost_III"
}

# Work out what multicast channel we are on (rather assumes there is only one space).
MCAST=`grep 'mcast_join =' /etc/gmond.conf  | grep -v \* | head -n 1 | awk  '{printf $3}' | sed 's/"//g'`
PORT=`grep 'port =' /etc/gmond.conf  | grep -v \* | head -n 1 | awk  '{printf $3}' | sed 's/"//'`
TTL=`grep '^mcast_ttl' /etc/gmond.conf | awk '{printf $2}'`
INTERFACE=`grep '^mcast_if' /etc/gmond.conf | awk '{printf $2}'`

[ -z "$MCAST" ] && MCAST="239.2.11.71"
[ -z "$PORT" ]  && PORT=8649
[ -z "$TTL" ] && TTL=1
[ -z "$INTERFACE" ] && INTERFACE="ipoib0"

if [ -e /usr/bin/vstat ] ; then
	
	NUMBER_OF_HCA=`/usr/bin/vstat | grep "found:" | awk ' {print $1}'`
	if [[ $NUMBER_OF_HCA == 1 ]] ; then
		one_hca
        else 
		two_hcas
	fi	
fi	
